#ifndef __space_h__
#define __space_h__



/******************************************/
/* The applications in this file were     */
/* designed and coded by Richard Karpen   */
/* University of Washington, Seattle 1998 */
/******************************************/


typedef	struct {
  OPDS	h;
  float	*r1, *r2, *r3, *r4, *asig,*ifn, *time, *reverbamount, *kx, *ky;
  float  ch1, ch2, ch3, ch4;
  FUNC   *ftp;
  AUXCH   auxch;
  float	*rrev1, *rrev2, *rrev3, *rrev4;
} SPACE;

typedef	struct {
  OPDS	h;
  float	*r1, *r2, *r3, *r4;
  SPACE *space;
} SPSEND;

typedef	struct {
  OPDS	h;
  float	*r, *ifn, *time, *kx, *ky;
  FUNC	*ftp;
} SPDIST;




extern void spaceset (SPACE *p);
extern void space (SPACE *p);
extern void spsendset (SPSEND *p);
extern void spsend (SPSEND *p);
extern void spdistset (SPDIST *p);
extern void spdist (SPDIST *p);


#endif __space_h__

